Subject: RE: [speechsc] Grammar freshness checking on RECOGNIZE

From: "Shanmugham, Saravanan" <[email-masked]>
Date: Mon, 17 Apr 2006 17:20:04 -0700

Hi Andrew, 
   The caching of URI and the effect of the caching hints and parameter
headers is covered in the document.

But I agree that, at which points exactly a fetch of an external URI is
done and hence its caching implication may not be clear. My understand
of this was that it should happen  both at DEFINE-GRAMMAR, RECOGNIZE,
SPEAK operations. 

So I propose adding the following text to the DEFINE-GRAMMAR, RECOGNIZE
and SPEAK operations.

  "The DEFINE-GRAMMAR/RECOGNIZE/SPEAK method implementation MUST do a
fetch of all external URI that is part of that operation. If caching is
implemented, this URI fetching MUST conform to the cache control hints
and parameter headers associated with the method in deciding whether it
should be fetched from cache or from the external server. If these
hints/parameters are not specified in the method, the values set for the
session using SET-PARAM/GET-PARAMS apply. If it was not set for the
session their default values apply."

What do you think?
Sarvi

     -----Original Message-----
     From: Andrew Wahbe [mailto:[email-masked]] 
     Sent: Monday, April 17, 2006 3:07 PM
     To: Shanmugham, Saravanan; IETF SPEECHSC (E-mail)
     Subject: Re: [speechsc] Grammar freshness checking on RECOGNIZE
     
     Actually I am referring to external grammars referenced 
     via URI and not to "session:" grammars. This "caching out" 
     behavior you refer to is related to the behavior that I 
     would like clarified. I don't think it is said explicitly 
     anywhere that grammar freshness should be evaluated on a 
     RECOGNIZE and if the grammar is stale, it should be 
     re-fetched and re-compiled. This is done even if we 
     haven't run out of room in our cache and needed to purge 
     old stuff (The "caching out" text in your clarification 
     seemed to be focusing on this case). Sorry if it is there 
     in the spec or your clarification and I missed it.
     
     There is definitely text that is related to the issue in 
     6.2.10 and 6.2.12. It is just not explicit. Since we are 
     fetching and using the grammars in two separate steps 
     here, DEFINE-GRAMMAR and RECOGNIZE, I think it is worth 
     calling out that the evaluation needs to take place on both steps.
     
     Andrew
     
     Shanmugham, Saravanan wrote:
     > I would like to refer to a proposed clarification on 
     grammar storage 
     > Vs caching I sent out in reponse to calrification 
     request from Jerry 
     > Carter. This attempts to calrify the differennce between 
     caching and 
     > storage.
     >
     > When you are refering to pre-defined grammar, I am 
     assuming you are 
     > talking about "session:" grammars, because those are the 
     ones that are 
     > STORED and don't get CACHED-OUT. Any other external 
     grammars refered 
     > through a URI, are essentially cached and hence would be 
     following 
     > cache control parameters specified for the session or 
     request. So if 
     > they are stale they would get cachedout and hence reloaded.
     > I could further clarify that this cache staleness should 
     happen at 
     > both DEFINE-GRAMMAR and RECOGNIZE commands.
     >
     > Does this clarification address your concern.
     >
     > Thx,
     > Sarvi
     >
     >      -----Original Message-----
     >      From: Andrew Wahbe [mailto:[email-masked]] 
     >      Sent: Monday, April 17, 2006 9:59 AM
     >      To: IETF SPEECHSC (E-mail)
     >      Subject: [speechsc] Grammar freshness checking on RECOGNIZE
     >      
     >      The VoiceXML Forum MRCP Liaison Committee is concerned 
     >      that seems to be no mention of the freshness of previously 
     >      defined grammars being evaluated on a RECOGNIZE. For 
     >      example, consider a long session where a grammar X was 
     >      defined at the start of the session and X was used in a 
     >      recognition at the end of the session. If the grammar 
     >      expired at some point in between, the session would be 
     >      using an "old", expired version of the grammar for 
     the recognition.
     >      
     >      The SRGS specification indicates in section 4.14 that this 
     >      check should be done:
     >      
     >      "Activation of a grammar is the point at which the 
     >      recognizer begins detection of user input matching the 
     >      grammar and is therefore analogous to the action of visual 
     >      or audio rendering of system output. As with output 
     >      rendering, grammar freshness should be checked close to 
     >      the moment of grammar activation."
     >      
     >      A statement should be added to the specification requiring 
     >      that the freshness of pre-defined grammars should be 
     >      checked on a RECOGNIZE and that expired grammars should be 
     >      re-fetched and re-compiled.
     >      
     >      Thanks,
     >      
     >      Andrew Wahbe
     >      VoiceXML Forum MRCP Liaison Committee
     >      
     >
     >
     >   

_______________________________________________
Speechsc mailing list
[email-masked]
https://www1.ietf.org/mailman/listinfo/speechsc

---

From: Andrew Wahbe <[email-masked]>
Date: Tue, 18 Apr 2006 01:01:34 -0400

Works for me.

(First sentence should probably be: ".... all external URIs that are 
part....")